package register

import (
	"git.urbach.dev/cli/q/src/asm"
	"git.urbach.dev/cli/q/src/cpu"
)

func (f *Machine) RegisterRegister(mnemonic asm.Mnemonic, a cpu.Register, b cpu.Register) {
	if f.Assembler.CanSkip(mnemonic, a, b) {
		return
	}

	f.Assembler.RegisterRegister(mnemonic, a, b)

	if mnemonic == asm.MOVE {
		f.UseRegister(a)
	}

	f.postInstruction()
}
